# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

# XXX:
# Note that 5.5.23-0jpp* is a port of tomcat5-5.5.23-6jpp to the existing
# 5.5.17 spec. This is so that the core tomcat5 codebase can be upgraded
# without requiring additional/newer thirdparty dependencies

# XXX:
# Note that the files matching the following globs have been removed:
#  /var/tmp/tomcat5-0-5.5.23-0jpp*-root/usr/lib/gcj/tomcat5/applet*
#  /var/tmp/tomcat5-0-5.5.23-0jpp*-root/usr/lib/gcj/tomcat5/jsp-examples*
#  /var/tmp/tomcat5-0-5.5.23-0jpp*-root/usr/lib/gcj/tomcat5/sample*
#  /var/tmp/tomcat5-0-5.5.23-0jpp*-root/usr/lib/gcj/tomcat5/servlets-examples*
#  /var/tmp/tomcat5-0-5.5.23-0jpp*-root/usr/lib/gcj/tomcat5/servlets-cgi*
#  /var/tmp/tomcat5-0-5.5.23-0jpp*-root/usr/lib/gcj/tomcat5/servlets-ssi*

%define _with_gcj_support 1

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}
# If you want only apis to be built,
# give rpmbuild option '--with apisonly'

%define with_apisonly %{?_with_apisonly:1}%{!?_with_apisonly:0}
%define without_apisonly %{!?_with_apisonly:1}%{?_with_apisonly:0}

# If you don't want direct ecj support to be built in,
# while eclipse-ecj isn't available,
# give rpmbuild option '--without ecj'

%define without_ecj %{?_without_ecj:1}%{!?_without_ecj:0}
%define with_ecj %{!?_without_ecj:1}%{?_without_ecj:0}

%define full_name jakarta-%{name}
%define full_jname jasper5
%define jname jasper
%define majversion 5.5
%define servletspec 2.4
%define jspspec 2.0
%define section devel

%define tcuid 91

%define packdname apache-tomcat-%{version}-src

# FHS 2.2 compliant tree structure
# see http://www.pathname.com/fhs/2.2/
%define confdir %{_sysconfdir}/%{name}
%define logdir %{_localstatedir}/log/%{name}
%define homedir %{_datadir}/%{name}
%define bindir %{_datadir}/%{name}/bin
%define tempdir %{_localstatedir}/cache/%{name}/temp
%define workdir %{_localstatedir}/cache/%{name}/work
%define appdir %{_localstatedir}/lib/%{name}/webapps
%define serverdir %{_localstatedir}/lib/%{name}/server
%define commondir %{_localstatedir}/lib/%{name}/common
%define shareddir %{_localstatedir}/lib/%{name}/shared

Summary: Apache Servlet/JSP Engine, RI for Servlet 2.4/JSP 2.0 API
Name: tomcat5
Version: 5.5.23
# XXX:
# 0jpp.1.0.x.el5 <-> 0jpp.2.el5 <-> 0jpp_4rh (RHAPS) <-> 0jpp_5rh (DevSuite)
Release: 0jpp.31%{?dist}
Epoch: 0
License: Apache Software License
Group: Networking/Daemons
URL: http://tomcat.apache.org/
Source0: http://www.apache.org/dist/tomcat/tomcat-5/v%{version}/src/%{packdname}.tar.gz
Source1: %{name}-%{majversion}.init
Source2: %{name}-%{majversion}.conf
Source3: %{name}-%{majversion}.wrapper
Source4: %{name}-%{majversion}.logrotate
Source5: %{name}-%{majversion}.relink
Patch0: %{name}-%{majversion}.link_admin_jar.patch
Patch1: %{name}-%{majversion}-skip-build-on-install.patch
Patch2: %{name}-%{majversion}-jt5-build.patch
Patch3: %{name}-%{majversion}-jtc-build.patch
Patch4: %{name}-%{majversion}-jtj-build.patch
Patch5: %{name}-%{majversion}-javaxssl.patch
#Patch6: %{name}-%{majversion}-bootstrap.MF.patch
Patch7: %{name}-%{majversion}-catalina.sh.patch
Patch8: %{name}-%{majversion}-jasper.sh.patch
Patch9: %{name}-%{majversion}-jspc.sh.patch
Patch10: %{name}-%{majversion}-setclasspath.sh.patch
Patch12: %{name}-%{majversion}-util-build.patch
Patch13: %{name}-%{version}-http11-build.patch
Patch14: %{name}-%{majversion}-jk-build.patch
Patch15: %{name}-%{majversion}-skip-native.patch
Patch16: %{name}-%{majversion}-jspc-classpath.patch
Patch17: %{name}-%{majversion}-gcj-class-init-workaround.patch
#FIXME Disable JSP pre-compilation on ppc64 and x390x
Patch18: %{name}-%{majversion}-skip-jsp-precompile.patch
# The following patch reverses a fix for a memory leak:
# https://issues.apache.org/jira/browse/MODELER-15 that forces the use of
# j-c-modeler-2.x
# Dont need this! We are building against 1.1 with a patch for MODELER-15
#Patch19: %{name}-%{version}-WebappClassLoader-commons-modeler.patch

# Fix for https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=244804
# svn diff -r 547082:547083 http://svn.apache.org/repos/asf/tomcat/servletapi \
#       | sed 's/servlet2.4-jsp2.0-tc5.x/servletapi/g' > \
#               %{name}-%{majversion}-CVE-2007-2449.patch
Patch20: %{name}-%{majversion}-CVE-2007-2449.patch
# Fix for https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=244808
# svn diff -r 547081:547082 http://svn.apache.org/repos/asf/tomcat/container \
#       | sed 's/tc5.5.x/container/g' > \
#               tomcat5-5.5-CVE-2007-2450.patch
Patch21: %{name}-%{majversion}-CVE-2007-2450.patch
# https://bugzilla.redhat.com/show_bug.cgi?id=254156
# Fix for CVE-2007-3386
Patch22: %{name}-%{majversion}-CVE-2007-3386.patch
# Fix for CVE-2007-3382 and CVE-2007-3385
Patch23: %{name}-%{majversion}-CVE-2007-3382_CVE-2007-3385.patch
# Fix for bz# 240739
Patch24: %{name}-%{version}-buildproperties-versionfix.patch
# Fix for CVE-2007-5342
Patch25: %{name}-%{majversion}-CVE-2007-5342.patch
# Fix for CVE-2007-5461
Patch26: %{name}-%{majversion}-CVE-2007-5461.patch
# Fix for CVE-2008-1232 (rhbz#457728)
Patch29: %{name}-%{version}-CVE-2008-1232.patch
# Fix for CVE-2008-1947 (rhbz#449917)
Patch30: %{name}-%{version}-CVE-2008-1947.patch
# Fix for CVE-2008-2370 (rhbz#458635)
Patch31: %{name}-%{version}-CVE-2008-2370.patch
# Fix for CVE-2008-2938 (rhbz#456216)
Patch32: %{name}-%{version}-CVE-2008-2938.patch
# Fix for CVE-2007-5333 (rhbz#427780)
Patch33: %{name}-%{version}-CVE-2007-5333.patch
# Fix for CVE-2008-5515 (rhbz#504759)
Patch34: %{name}-%{version}-ASPATCH426-CVE-2008-5515.patch
# Fix for CVE-2009-0033 (rhbz#503981)
Patch35: %{name}-%{version}-ASPATCH428-CVE-2009-0033.patch
# Fix for CVE-2009-0580 (rhbz#503981)
Patch36: %{name}-%{version}-ASPATCH430-CVE-2009-0580.patch
# Fix for CVE-2008-0781 (rhbz#504163)
Patch37: %{name}-%{version}-ASPATCH421-CVE-2009-0781.patch
# Fix for CVE-2008-0783 (rhbz#504163)
Patch38: %{name}-%{version}-ASPATCH433-CVE-2009-0783.patch
Patch39: %{name}-%{version}-CVE-2009-2693-2901-2902.patch
Patch40: %{name}-%{version}-CVE-2010-2227.patch
Patch41: %{name}-%{version}-ConcurrentModification-MapperListener-rhbz623465.patch
Patch42: %{name}-%{version}-rhbz530089-cookieparsing.patch
# porting patch for JBPAPP-3626
Patch43: %{name}-%{majversion}-hostmanager-welcomefiles-webxml.patch
# porting patch for JBPAPP-3627
Patch44: %{name}-%{majversion}-host-manager_help_link.patch
# Resolves rhbz 674601 JDK Double.parseDouble Dos
Patch45: %{name}-%{majversion}-rhbz-674601.patch
#Patch46: %{name}-%{majversion}-CVE-2011-2526.patch
#Patch47: %{name}-5.5.23-rhbz-543995.patch
Patch48: %{name}-5.5.23-CVE-2011-1184-rhbz-744984.patch
Patch49: %{name}-5.5.23-CVE-2011-2204-rhbz-719188.patch
Patch50: %{name}-5.5.23-CVE-2011-0013-rhbz-675933.patch
Patch51: %{name}-5.5.23-CVE-2011-3718-rhbz-675933.patch
Patch52: %{name}-5.5.23-CVE-2012-0022.patch

BuildRoot: %{_tmppath}/%{name}-%{epoch}-%{version}-%{release}-root
%if ! %{gcj_support}
BuildArch: noarch
%endif

Requires: jpackage-utils >= 0:1.6.0
# xml parsing packages
Requires: xerces-j2 >= 0:2.7.1
Requires: xml-commons-apis >= 1.3
# jakarta-commons packages
Requires: jakarta-commons-daemon >= 1.0.1
Requires: jakarta-commons-launcher >= 0:0.9
# alternatives
Requires: jndi-ldap
# And it needs its own API subpackages for running
Requires: %{name}-common-lib = %{epoch}:%{version}-%{release}
Requires: %{name}-server-lib = %{epoch}:%{version}-%{release}
# And it needs its own API subpackages before being installed
Requires(post): %{name}-common-lib = %{epoch}:%{version}-%{release}
Requires(post): %{name}-server-lib = %{epoch}:%{version}-%{release}

Buildrequires: jpackage-utils >= 0:1.6.0
BuildRequires: ant >= 0:1.6.2
%if %{with_apisonly}
BuildRequires: java-devel >= 0:1.4.2
%endif
%if %{without_apisonly}
%if %{with_ecj}
BuildRequires: eclipse-ecj >= 0:3.1.1
%endif
BuildRequires: ant-trax
BuildRequires: xalan-j2
BuildRequires: jakarta-commons-beanutils >= 1.7
BuildRequires: jakarta-commons-collections >= 0:3.1
BuildRequires: jakarta-commons-daemon >= 1.0.1
BuildRequires: jakarta-commons-dbcp >= 0:1.2.1
BuildRequires: jakarta-commons-digester >= 0:1.7
BuildRequires: jakarta-commons-logging >= 0:1.0.4
BuildRequires: jakarta-commons-fileupload >= 0:1.0
# Require modeler with MODELER-15 patch applied
BuildRequires: jakarta-commons-modeler >= 1.1-8jpp.1.0.1
BuildRequires: jakarta-commons-pool >= 0:1.2
BuildRequires: jakarta-commons-launcher >= 0:0.9
BuildRequires: jakarta-commons-el >= 0:1.0
BuildRequires: jaas
BuildRequires: jdbc-stdext >= 0:2.0
BuildRequires: jndi >= 0:1.2.1
BuildRequires: jndi-ldap
BuildRequires: jsse >= 0:1.0.3
BuildRequires: junit >= 0:3.8.1
BuildRequires: mx4j >= 0:3.0.1
BuildRequires: regexp >= 0:1.3
BuildRequires: struts >= 0:1.2.7
BuildRequires: xerces-j2 >= 0:2.7.1
# xml-commons-apis is needed by Xerces-J2
BuildRequires: xml-commons-apis >= 1.3
# FIXME taglibs-standard is not listed in the Tomcat build.properties.default
BuildRequires: jakarta-taglibs-standard >= 0:1.1.0
# formerly non-free stuff
# geronimo-specs replaces non-free jta
#BuildRequires: geronimo-jta-1.0.1B-api
BuildRequires: jta >= 0:1.0.1
# jaf can be provided by classpathx-jaf
#BuildRequires: jaf >= 0:1.0.2
BuildRequires: jaf >= 0:1.0.1
# javamail can be provided by classpathx-mail
#BuildRequires: javamail >= 0:1.3.3
BuildRequires: javamail >= 0:1.3.1
# libgcj aot-compiled native libraries
%if %{gcj_support}
BuildRequires:    	java-gcj-compat-devel >= 1.0.43
Requires(post):   	java-gcj-compat >= 1.0.31
Requires(postun): 	java-gcj-compat >= 1.0.31
%endif
%endif

%description
Tomcat is the servlet container that is used in the official Reference
Implementation for the Java Servlet and JavaServer Pages technologies.
The Java Servlet and JavaServer Pages specifications are developed by
Sun under the Java Community Process.

Tomcat is developed in an open and participatory environment and
released under the Apache Software License. Tomcat is intended to be
a collaboration of the best-of-breed developers from around the world.
We invite you to participate in this open development project. To
learn more about getting involved, click here.

%if %{without_apisonly}
%package webapps
Group: System Environment/Applications
Requires(pre): %{name} = %{epoch}:%{version}-%{release}
Requires: jakarta-taglibs-standard >= 0:1.1.0
Summary: Web applications for Jakarta Tomcat

%description webapps
Web applications for Jakarta Tomcat

%package admin-webapps
Group: System Environment/Applications
Requires(pre): %{name} = %{epoch}:%{version}-%{release}
Requires: struts >= 0:1.1
Summary: The administrative web applications for Jakarta Tomcat

%if %{gcj_support}
Requires(post): java-gcj-compat >= 1.0.31
Requires(postun): java-gcj-compat >= 1.0.31
%endif


%description admin-webapps
The administrative web applications (admin and manager) for Jakarta Tomcat
%endif

%package servlet-%{servletspec}-api
Group: Internet/WWW/Dynamic Content
Requires: /usr/sbin/update-alternatives
Summary: Jakarta Tomcat Servlet implementation classes
Obsoletes: servletapi5
Provides: servlet
Provides: servlet5
Provides: servlet24
Provides: servletapi5
%if %{gcj_support}
# libgcj aot-compiled native libraries
Requires(post):   	java-gcj-compat >= 1.0.31
Requires(postun): 	java-gcj-compat >= 1.0.31
%endif

%description servlet-%{servletspec}-api
Contains the implementation classes
of the Jakarta Tomcat Servlet API (packages javax.servlet).

%package servlet-%{servletspec}-api-javadoc
Group: Development/Documentation
Summary: Javadoc generated documentation for %{name}-servlet-%{servletspec}-api
Obsoletes: servletapi5-javadoc
Provides: servletapi5-javadoc
Requires(post): coreutils
Requires(postun): coreutils

%description servlet-%{servletspec}-api-javadoc
Contains the javadoc generated documentation for the implementation classes
of the Jakarta Tomcat Servlet and JSP APIs (packages javax.servlet).

%package jsp-%{jspspec}-api
Group: Internet/WWW/Dynamic Content
Requires: /usr/sbin/update-alternatives
Requires: servlet24
# We need this to indirectly get rid of legacy jsp included in old
# servlet packages (one day we will be able to remove this)
Requires(pre): %{name}-servlet-%{servletspec}-api = %{epoch}:%{version}-%{release}
Summary: Jakarta Tomcat Servlet and JSP implementation classes
Provides: jsp
%if %{gcj_support}
# libgcj aot-compiled native libraries
Requires(post):   	java-gcj-compat >= 1.0.31
Requires(postun): 	java-gcj-compat >= 1.0.31
%endif

%description jsp-%{jspspec}-api
Contains the implementation classes
of the Jakarta Tomcat JSP API (packages javax.servlet.jsp).

%package jsp-%{jspspec}-api-javadoc
Group: Development/Documentation
Summary: Javadoc generated documentation for %{name}-jsp-%{jspspec}-api
Requires(post): coreutils
Requires(postun): coreutils

%description jsp-%{jspspec}-api-javadoc
Contains the javadoc generated documentation for the implementation classes
of the Jakarta Tomcat JSP API (packages javax.servlet.jsp).

%if %{without_apisonly}
%package common-lib
Group: Development/Compilers
Summary: Libraries needed to run the Tomcat Web container (part)
Requires: java >= 0:1.4.2
Requires(post): jpackage-utils >= 0:1.6.0
Requires: ant >= 0:1.6
Requires(post): ant >= 0:1.6
Requires: jakarta-commons-collections >= 0:3.1
Requires(post): jakarta-commons-collections >= 0:3.1
Requires: jakarta-commons-dbcp >= 0:1.2.1
Requires(post): jakarta-commons-dbcp >= 0:1.2.1
Requires: jakarta-commons-el >= 0:1.0
Requires(post): jakarta-commons-el >= 0:1.0
Requires: jakarta-commons-logging >= 0:1.0.4
Requires(post): jakarta-commons-logging >= 0:1.0.4
# FIXME commons-pool is not listed in the Tomcat build.properties.default
Requires: jakarta-commons-pool >= 0:1.2
Requires(post): jakarta-commons-pool >= 0:1.2
# jaf can be provided by classpathx-jaf
Requires: jaf >= 0:1.0.1
Requires(post): jaf >= 0:1.0.1
# javamail can be provided by classpathx-mail
Requires: javamail >= 0:1.3.1
Requires(post): javamail >= 0:1.3.1
Requires: jdbc-stdext
Requires(post): jdbc-stdext
Requires: jndi
Requires(post): jndi
# geronimo-specs replaces non-free jta
#Requires: geronimo-jta-1.0.1B-api
Requires: jta >= 0:1.0.1
#Requires(post): geronimo-jta-1.0.1B-api
Requires(post): jta >= 0:1.0.1
Requires: mx4j >= 0:3.0.1
Requires(post): mx4j >= 0:3.0.1
%if %{with_ecj}
Requires: eclipse-ecj >= 0:3.1.1
Requires(post): eclipse-ecj >= 0:3.1.1
%endif
# Other subpackages must go in first
Requires(post): %{name}-servlet-%{servletspec}-api = %{epoch}:%{version}-%{release}
Requires(post): %{name}-jsp-%{jspspec}-api = %{epoch}:%{version}-%{release}
Requires(post): %{name}-%{jname} = %{epoch}:%{version}-%{release}
Requires: %{name}-servlet-%{servletspec}-api = %{epoch}:%{version}-%{release}
Requires: %{name}-jsp-%{jspspec}-api = %{epoch}:%{version}-%{release}
Requires: %{name}-%{jname} = %{epoch}:%{version}-%{release}
%if %{gcj_support}
# libgcj aot-compiled native libraries
Requires(post):   	java-gcj-compat >= 1.0.31
Requires(postun): 	java-gcj-compat >= 1.0.31
%endif

%description common-lib
Libraries needed to run the Tomcat Web container (part)

%package server-lib
Group: Development/Compilers
Summary: Libraries needed to run the Tomcat Web container (part)
Requires(post): jpackage-utils >= 0:1.6.0
Requires: jakarta-commons-beanutils >= 0:1.7.0
Requires(post): jakarta-commons-beanutils >= 0:1.7.0
Requires: jakarta-commons-digester >= 0:1.6
Requires(post): jakarta-commons-digester >= 0:1.6
Requires: jakarta-commons-el >= 0:1.0
Requires(post): jakarta-commons-el >= 0:1.0
Requires: jakarta-commons-fileupload >= 0:1.0-1jpp
Requires(post): jakarta-commons-fileupload >= 0:1.0-1jpp
Requires: jakarta-commons-logging >= 0:1.0.4
Requires(post): jakarta-commons-logging >= 0:1.0.4
# Require modeler with MODELER-15 patch applied
Requires: jakarta-commons-modeler >= 1.1-8jpp.1.0.1
Requires(post): jakarta-commons-modeler >= 1.1-8jpp.1.0.1
Requires: jaas
Requires(post): jaas
Requires: mx4j >= 0:3.0.1
Requires(post): mx4j >= 0:3.0.1
Requires: regexp >= 0:1.3
Requires(post): regexp >= 0:1.3
# Other subpackages must go in first
Requires: %{name}-%{jname} = %{epoch}:%{version}-%{release}
Requires(post): %{name}-%{jname} = %{epoch}:%{version}-%{release}
%if %{gcj_support}
# libgcj aot-compiled native libraries
Requires(post):   	java-gcj-compat >= 1.0.31
Requires(postun): 	java-gcj-compat >= 1.0.31
%endif

%description server-lib
Libraries needed to run the Tomcat Web container (part)

%package %{jname}
Group: Development/Compilers
Requires: %{name}-servlet-%{servletspec}-api = %{epoch}:%{version}-%{release}
Summary: Compiler JARs and associated scripts for %{name}
Obsoletes: jasper5
Provides: jasper5
%if %{gcj_support}
# libgcj aot-compiled native libraries
Requires(post):   	java-gcj-compat >= 1.0.31
Requires(postun): 	java-gcj-compat >= 1.0.31
%endif

%description %{jname}
Compiler JARs and associated scripts for %{name}

%package %{jname}-javadoc
Group: Development/Documentation
Summary: Javadoc generated documentation for %{name}-%{jname}
Obsoletes: jasper5-javadoc
Provides: jasper5-javadoc

%description %{jname}-javadoc
Javadoc for generated documentation %{name}-%{jname}
%endif

%prep
cat <<EOT

                If you want only apis to be built,
                give rpmbuild option '--with apisonly'

		If you don''t want direct ecj support to be built in,
		while eclipse-ecj isn''t available,
		give rpmbuild option '--without ecj'


EOT

rm -rf $RPM_BUILD_DIR/%{name}-%{version}

%setup -q -c -T -a 0

cd %{packdname}
%patch0 -b .p0
%patch1 -b .p1
%patch2 -b .p2
%patch3 -b .p3
%patch4 -b .p4
%patch5 -b .p5
#%patch6 -p1
%patch7 -b .p7
%patch8 -b .p8
%patch9 -b .p9
%patch10 -b .p10
# omit jdtcompilerpatch for eclipse-ecj >= 3.1
# %%patch11 -b .p11
%patch12 -b .p12
%patch13 -b .p13
%patch14 -b .p14
%if %{gcj_support}
%patch15 -b .p15
%patch16 -b .p16
%patch17 -b .p17
%ifarch ppc64 s390x
%patch18 -b .p18
%endif
%endif
# XXX:
# Dont need this! Building against j-c-modeler 1.1 with MODELER-15 patch
# %%patch19 -b .p19
%patch20
%patch21
%patch22
%patch23
%patch24
%patch25
%patch26

# Fix for CVE-2008-1232
%patch29

# Fix for CVE-2008-1947
%patch30

# Fix for CVE-2008-2370
%patch31

# Fix for CVE-2008-2938
%patch32
# Fix for CVE-2008-5333
%patch33
# Fix for CVE-2008-5515
%patch34
# Fix for CVE-2009-0033
%patch35
# Fix for CVE-2008-0580
%patch36
# Fix for CVE-2008-0783
%patch37
# Fix for CVE-2008-0781
%patch38
%patch39
# CVE-2010-2227
%patch40
%patch41
# rhbz530089
%patch42
%patch43
%patch44
%patch45
#%patch46
#%patch47
%patch48
%patch49
%patch50
%patch51
%patch52

find . -name "*.orig" -exec rm -f {} \;

%if %{without_ecj}
rm %{jname}/src/share/org/apache/jasper/compiler/JDTCompiler.java
%endif

%build
#clp#export CLASSPATH=%(build-classpath xml-commons-apis xalan-j2)

# Remove pre-built jars
for dir in $RPM_BUILD_DIR/%{name}-%{version}/%{packdname} ; do
    find $dir -name "*.jar" | xargs -t rm -f
done

# Remove garbled class files
pushd $RPM_BUILD_DIR/%{name}-%{version}/%{packdname}
    rm -rf connectors/jk/jkstatus/build
popd

pushd $RPM_BUILD_DIR/%{name}-%{version}/%{packdname}
    cp build/LICENSE .
popd 

# build jspapi and servletapi as ant dist will require them later
pushd $RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/servletapi
    pushd jsr154
        ant -Dservletapi.build=build \
            -Dservletapi.dist=dist \
            -Dbuild.compiler=modern dist
    popd
    pushd jsr152
        ant -Dservletapi.build=build \
            -Dservletapi.dist=dist \
            -Dbuild.compiler=modern dist
    popd
popd

%if %{without_apisonly}
# build jasper subpackage
#clp#CLASSPATH=%(build-classpath xml-commons-apis xalan-j2)
#clp#export CLASSPATH=$CLASSPATH:$RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/jakarta-servletapi-5/jsr154/dist/lib/servlet-api.jar
pushd $RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/%{jname}
    cat > build.properties <<EOBP
ant.jar=$(build-classpath ant)
servlet-api.jar=$RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/servletapi/jsr154/dist/lib/servlet-api.jar
jsp-api.jar=$RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/servletapi/jsr152/dist/lib/jsp-api.jar
tools.jar=%{java.home}/lib/tools.jar
xerces.jar=$(build-classpath xerces-j2)
xercesImpl.jar=$(build-classpath jaxp_parser_impl)
xmlParserAPIs.jar=$(build-classpath xml-commons-apis)
commons-el.jar=$(build-classpath commons-el)
commons-collections.jar=$(build-classpath commons-collections)
commons-logging.jar=$(build-classpath commons-logging)
commons-daemon.jar=$(build-classpath commons-daemon)
junit.jar=$(build-classpath junit)
jasper-compiler-jdt.jar=$(build-classpath jdtcore)
EOBP
    # can't use jikes to build tomcat4 (strange)
    ant -Djava.home=%{java_home} -Dbuild.compiler=modern javadoc
popd

# build tomcat 5
pushd $RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/build
    cat >> build.properties << EOBP
# bug 240739
#version=%{version}
ant.jar=%{_javadir}/ant.jar
ant-launcher.jar=%{_javadir}/ant.jar
jtc.home=$RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/connectors/
%{jname}.home=$RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/%{jname}
commons-beanutils.jar=$(build-classpath commons-beanutils)
commons-fileupload.jar=$(build-classpath commons-fileupload)
commons-collections.jar=$(build-classpath commons-collections)
commons-daemon.jar=$(build-classpath commons-daemon)
commons-dbcp.jar=$(build-classpath commons-dbcp)
commons-digester.jar=$(build-classpath commons-digester)
commons-el.jar=$(build-classpath commons-el)
commons-launcher.jar=$(build-classpath commons-launcher)
commons-logging.jar=$(build-classpath commons-logging)
commons-logging-api.jar=$(build-classpath commons-logging-api)
commons-modeler.jar=$(build-classpath commons-modeler)
commons-pool.jar=$(build-classpath commons-pool)
jmx.jar=$(build-classpath mx4j/mx4j-jmx.jar)
jmx-remote.jar=$(build-classpath mx4j/mx4j-remote.jar)
jmx-tools.jar=$(build-classpath mx4j/mx4j-tools.jar)
jmxri.jar=$(build-classpath mx4j/mx4j-jmx.jar)
junit.jar=$(build-classpath junit)
regexp.jar=$(build-classpath regexp)
servlet-api.jar=$RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/servletapi/jsr154/dist/lib/servlet-api.jar
jsp-api.jar=$RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/servletapi/jsr152/dist/lib/jsp-api.jar
servlet.doc=$RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/servletapi/jsr154/dist/docs/api
xercesImpl.jar=$(build-classpath jaxp_parser_impl)
xml-apis.jar=$(build-classpath xml-commons-apis)
struts.jar=$(build-classpath struts)
struts.lib=%{_datadir}/struts
activation.jar=$(build-classpath jaf)
mail.jar=$(build-classpath javamail/mailapi)
jta.jar=$(build-classpath jta)
jaas.jar=$(build-classpath jaas)
jndi.jar=$(build-classpath jndi)
jdbc20ext.jar=$(build-classpath jdbc-stdext)
jcert.jar=$(build-classpath jsse/jcert)
jnet.jar=$(build-classpath jsse/jnet)
jsse.jar=$(build-classpath jsse/jsse)
servletapi.build.notrequired=true
jspapi.build.notrequired=true
EOBP
export CLASSPATH=$RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/servletapi/jsr154/dist/lib/servlet-api.jar
# can't use jikes to build tomcat4 (strange)
    ant -Dbuild.compiler=modern -Djava.home=%{java_home} build
popd

# build the connectors
pushd $RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/connectors
# use the JARs created above to build
export CLASSPATH=$RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/servletapi/jsr154/dist/lib/servlet-api.jar:$RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/jakarta-tomcat-5/build/server/lib/catalina.jar
    cat > build.properties << EOBP
activation.jar=$(build-classpath jaf)
ant.jar=%{_javadir}/ant.jar
junit.jar=$(build-classpath junit)
commons-beanutils.jar=$(build-classpath commons-beanutils)
commons-collections.jar=$(build-classpath commons-collections)
commons-daemon.jar=$(build-classpath commons-daemon)
commons-digester.jar=$(build-classpath commons-digester)
commons-fileupload.jar=$(build-classpath commons-fileupload)
commons-logging.jar=$(build-classpath commons-logging)
commons-logging-api.jar=$(build-classpath commons-logging-api)
commons-modeler.jar=$(build-classpath commons-modeler)
commons-pool.jar=$(build-classpath commons-pool)
regexp.jar=$(build-classpath regexp)
jmx.jar=$(build-classpath mx4j/mx4j-jmx)
activation.jar=$(build-classpath jaf)
mail.jar=$(build-classpath javamail/mailapi)
#jta.jar=$(build-classpath geronimo-jta-1.0.1B-api)
jta.jar=$(build-classpath jta)
jaas.jar=$(build-classpath jaas)
jndi.jar=$(build-classpath jndi)
jdbc20ext.jar=$(build-classpath jdbc-stdext)
jcert.jar=$(build-classpath jsse/jcert)
jnet.jar=$(build-classpath jsse/jnet)
jsse.jar=$(build-classpath jsse/jsse)
tomcat5.home=../../build/build
EOBP
    ant -Dbuild.compiler=modern -Djava.home=%{java_home} build
popd
%endif

%install
rm -rf $RPM_BUILD_ROOT

install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
%if %{without_apisonly}
CLASSPATH=%(build-classpath xalan-j2 xml-commons-apis jakarta-taglibs-core jakarta-taglibs-standard mx4j/mx4j-jmx struts)
export CLASSPATH=$CLASSPATH:$RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/servletapi/jsr152/dist/lib/jsp-api.jar:$RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/servletapi/jsr154/dist/lib/servlet-api.jar
# build initial path structure
install -d -m 775 $RPM_BUILD_ROOT{%{confdir},%{logdir},%{homedir},%{bindir}}
touch ${RPM_BUILD_ROOT}%{logdir}/catalina.out
install -d -m 775 $RPM_BUILD_ROOT{%{serverdir},%{tempdir},%{workdir}}
install -d -m 775 $RPM_BUILD_ROOT{%{appdir},%{commondir},%{shareddir}}
install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}/{rc.d,logrotate.d}
install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d
install -d -m 755 $RPM_BUILD_ROOT%{_bindir}
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 755 %{SOURCE5} $RPM_BUILD_ROOT/%{bindir}/relink
# SysV init and configuration
install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/%{name}
install %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/%{name}
install %{SOURCE2} $RPM_BUILD_ROOT%{confdir}/%{name}.conf
pushd $RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/build
    export usejikes=false
    export OPT_JAR_LIST="ant/ant-trax xalan-j2-serializer"
    ant -Dbuild.compiler=modern -Djava.home=%{java_home} dist
    pushd dist
        mv bin/* $RPM_BUILD_ROOT%{bindir}
        mv common/* $RPM_BUILD_ROOT%{commondir}
        mv conf/* $RPM_BUILD_ROOT%{confdir}
        mv server/* $RPM_BUILD_ROOT%{serverdir}
        mv shared/* $RPM_BUILD_ROOT%{shareddir}
        mv webapps/* $RPM_BUILD_ROOT%{appdir}
    popd
    pushd build/conf
	mv jk2.properties jk2.manifest jkconf.ant.xml jkconfig.manifest \
           shm.manifest tomcat-jk2.manifest uriworkermap.properties \
           workers.properties workers.properties.minimal workers2.properties \
           workers2.properties.minimal \
             $RPM_BUILD_ROOT%{confdir}
    popd
popd
# create reloctomcat5 (is this really necessary anymore?)
cat >> $RPM_BUILD_ROOT%{bindir}/reloctomcat5 << EORLTC
#!/bin/sh
#

echo "relocating http & ajp ports to 81xx"

sed -e 's;8080;8180;' \
    -e 's;8081;8181;' \
    -e 's;8082;8182;' \
    -e 's;8443;8543;' \
    -e 's;8009;8109;' \
    %{confdir}/server.xml > %{confdir}/server.xml.reloc

mv %{confdir}/server.xml %{confdir}/server.xml.bak
cp %{confdir}/server.xml.reloc %{confdir}/server.xml

EORLTC
# rename catalina.sh into dtomcat5 to let wrapper take precedence
install $RPM_BUILD_ROOT%{bindir}/catalina.sh \
    $RPM_BUILD_ROOT%{_bindir}/d%{name}
rm -f $RPM_BUILD_ROOT%{bindir}/catalina.sh.*
# Remove leftover files
rm -f $RPM_BUILD_ROOT%{bindir}/*.orig
# install wrapper as tomcat5
install %{SOURCE3} $RPM_BUILD_ROOT%{_bindir}/%{name}
# install logrotate support
install %{SOURCE4} ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/%{name}
# remove / reorder non-usefull stuff
rm -rf $RPM_BUILD_ROOT%{homedir}/src/
rm -f  $RPM_BUILD_ROOT%{bindir}/*.sh $RPM_BUILD_ROOT%{bindir}/*.bat
# FHS compliance patches, not easy to track them all boys :)
for i in $RPM_BUILD_ROOT%{confdir}/%{name}.conf \
         $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/%{name} \
         $RPM_BUILD_ROOT%{_bindir}/d%{name} \
         $RPM_BUILD_ROOT%{_bindir}/%{name} \
         $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/%{name} \
         $RPM_BUILD_ROOT%{bindir}/relink \
         $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/%{name}; do
    perl -pi -e "s|\@\@\@TCCONF\@\@\@|%{confdir}|g;" $i
    perl -pi -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g;" $i
    perl -pi -e "s|\@\@\@TCBIN\@\@\@|%{bindir}|g;" $i
    perl -pi -e "s|\@\@\@TCCOMMON\@\@\@|%{commondir}|g;" $i
    perl -pi -e "s|\@\@\@TCSERVER\@\@\@|%{serverdir}|g;" $i
    perl -pi -e "s|\@\@\@TCSHARED\@\@\@|%{shareddir}|g;" $i
    perl -pi -e "s|\@\@\@TCAPP\@\@\@|%{appdir}|g;" $i
    perl -pi -e "s|\@\@\@TCLOG\@\@\@|%{logdir}|g;" $i
done
# Remove local JARs (to be replaced with jpp links in post)
pushd $RPM_BUILD_ROOT%{serverdir}/lib
    find . -name "*.jar" -not -name "catalina*" \
                         -not -name "servlets-*" \
                         -not -name "tomcat-*" | xargs -t rm -f
    # catalina-ant will be installed in a public repository
    mv catalina-ant.jar $RPM_BUILD_ROOT%{_javadir}/catalina-ant-%{version}.jar
    pushd $RPM_BUILD_ROOT%{_javadir}
        ln -fs catalina-ant-%{version}.jar catalina-ant5.jar
    popd
    # catalina* jars will be installed in a public repository
    for i in catalina*.jar; do
        j=`echo $i | sed 's:\.jar$::'`
        mv $j.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/$j-%{version}.jar
        pushd $RPM_BUILD_ROOT%{_javadir}/%{name}
            ln -sf $j-%{version}.jar $j.jar
        popd
        ln -sf %{_javadir}/%{name}/$j.jar $j.jar
    done
    # servlets* jars will be installed in a public repository
    for i in servlets-*.jar; do
        j=`echo $i | sed 's:\.jar$::'`
        mv $j.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/$j-%{version}.jar
        pushd $RPM_BUILD_ROOT%{_javadir}/%{name}
            ln -sf $j-%{version}.jar $j.jar
        popd
        ln -sf %{_javadir}/%{name}/$j.jar $j.jar
    done
    # tomcat* jars will be installed in a public repository
    for i in tomcat-*.jar; do
        j=`echo $i | sed 's:\.jar$::'`
        mv $j.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/$j-%{version}.jar
        pushd $RPM_BUILD_ROOT%{_javadir}/%{name}
            ln -sf $j-%{version}.jar $j.jar
        popd
        ln -sf %{_javadir}/%{name}/$j.jar $j.jar
    done
popd
# Process admin webapp server/webapps/admin
pushd $RPM_BUILD_ROOT%{serverdir}/webapps/admin/WEB-INF/lib
    find . -name "*.jar" -not -name 'catalina-admin*' | xargs -t rm -f
    for i in catalina-admin; do
        cp $i.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/$i-%{version}.jar
        pushd $RPM_BUILD_ROOT%{_javadir}/%{name}
            ln -sf $i-%{version}.jar $i.jar
        popd
    done
popd
# Process manager webapp server/webapps/manager
pushd $RPM_BUILD_ROOT%{serverdir}/webapps/manager/WEB-INF/lib
    for i in catalina-manager; do
        cp $i.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/$i-%{version}.jar
        pushd $RPM_BUILD_ROOT%{_javadir}/%{name}
            ln -sf $i-%{version}.jar $i.jar
        popd
    done
popd
# Process host-manager webapp server/webapps/host-manager
pushd $RPM_BUILD_ROOT%{serverdir}/webapps/host-manager/WEB-INF/lib
    for i in catalina-host-manager; do
        cp $i.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/$i-%{version}.jar
        pushd $RPM_BUILD_ROOT%{_javadir}/%{name}
            ln -sf $i-%{version}.jar $i.jar
        popd
    done
popd
# Process common/lib
pushd $RPM_BUILD_ROOT%{commondir}/lib
    find . -name "*.jar" -not -name "%{jname}*" \
                         -not -name "naming*" | xargs -t rm -f
    # jasper's jars will be installed in a public repository
    for i in %{jname}-compiler %{jname}-runtime; do
        j=`echo $i | sed 's:%{jname}-:%{jname}5-:'`
        mv $i.jar $RPM_BUILD_ROOT%{_javadir}/$j-%{version}.jar
        pushd $RPM_BUILD_ROOT%{_javadir}
            ln -sf $j-%{version}.jar $j.jar
        popd
    done
    # naming* jars will be installed in a public repository
    for i in naming-*.jar; do
        j=`echo $i | sed 's:\.jar$::'`
        mv $j.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/$j-%{version}.jar
        pushd $RPM_BUILD_ROOT%{_javadir}/%{name}
            ln -sf $j-%{version}.jar $j.jar
        popd
        ln -sf %{_javadir}/%{name}/$j.jar $j.jar
    done
popd
# Process common/endorsed
pushd $RPM_BUILD_ROOT%{commondir}/endorsed
    find . -name "*.jar" | xargs -t rm -f
popd
# avoid duplicate servlet.jar
rm -f $RPM_BUILD_ROOT%{commondir}/lib/servlet.jar
# Perform FHS translation
# (final links)
pushd $RPM_BUILD_ROOT%{homedir}
    [ -d bin ] || ln -fs %{bindir} bin
    [ -d common ] || ln -fs %{commondir} common
    [ -d conf ] || ln -fs %{confdir} conf
    [ -d logs ] || ln -fs %{logdir} logs
    [ -d server ] || ln -fs %{serverdir} server
    [ -d shared ] || ln -fs %{shareddir} shared
    [ -d webapps ] || ln -fs %{appdir} webapps
    [ -d work ] || ln -fs %{workdir} work
    [ -d temp ] || ln -fs %{tempdir} temp
popd
cd $RPM_BUILD_DIR/%{name}-%{version}/%{packdname}
find $RPM_BUILD_ROOT%{homedir} -type l -maxdepth 1 | \
    sed s+$RPM_BUILD_ROOT++g > homelinks
%endif
# begin servlet api subpackage install
pushd $RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/servletapi
    install -m 644 jsr154/dist/lib/servlet-api.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}-servlet-%{servletspec}-api-%{version}.jar
    pushd $RPM_BUILD_ROOT%{_javadir}
        ln -sf %{name}-servlet-%{servletspec}-api-%{version}.jar \
            %{name}-servlet-%{servletspec}-api.jar
        # For backward compatibility with old JPP packages
        ln -sf %{name}-servlet-%{servletspec}-api-%{version}.jar \
            servletapi5.jar
    popd
    # javadoc servlet
    install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-servlet-%{servletspec}-api-%{version}
    cp -pr jsr154/build/docs/api/* \
        $RPM_BUILD_ROOT%{_javadocdir}/%{name}-servlet-%{servletspec}-api-%{version}
    # ghost symlink
    ln -s %{name}-servlet-%{servletspec}-api-%{version} \
        $RPM_BUILD_ROOT%{_javadocdir}/%{name}-servlet-%{servletspec}-api
popd
# begin jsp api subpackage install
pushd $RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/servletapi
    install -m 644 jsr152/dist/lib/jsp-api.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}-jsp-%{jspspec}-api-%{version}.jar
    pushd $RPM_BUILD_ROOT%{_javadir}
        ln -sf %{name}-jsp-%{jspspec}-api-%{version}.jar \
            %{name}-jsp-%{jspspec}-api.jar
        # For backward compatibility with old JPP packages
        ln -sf %{name}-jsp-%{jspspec}-api-%{version}.jar \
            jspapi.jar
    popd
    # javadoc jsp
    install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-jsp-%{jspspec}-api-%{version}
    cp -pr jsr152/build/docs/api/* \
        $RPM_BUILD_ROOT%{_javadocdir}/%{name}-jsp-%{jspspec}-api-%{version}
    # ghost symlink
    ln -s %{name}-jsp-%{jspspec}-api-%{version} \
        $RPM_BUILD_ROOT%{_javadocdir}/%{name}-jsp-%{jspspec}-api
popd
%if %{without_apisonly}
# begin jasper subpackage install
pushd $RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/%{jname}
    install -m755 src/bin/jspc.sh \
        $RPM_BUILD_ROOT%{_bindir}/jspc5.sh
    install -m755 src/bin/%{jname}.sh \
        $RPM_BUILD_ROOT%{_bindir}/%{full_jname}.sh
popd
pushd $RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/container
    install -m755 catalina/src/bin/setclasspath.sh \
        $RPM_BUILD_ROOT%{_bindir}/%{full_jname}-setclasspath.sh
popd
# javadoc
install -d -m755 $RPM_BUILD_ROOT%{_javadocdir}/%{jname}-%{version}
pushd $RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/%{jname}
    cp -pr build/javadoc/* \
        $RPM_BUILD_ROOT%{_javadocdir}/%{jname}-%{version}
    # ghost symlink
    ln -s %{jname}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{jname}
popd

# disable the juli log manager until the classpath
# java.util.logging.LogManager is fixed
rm -f $RPM_BUILD_ROOT%{bindir}/tomcat-juli.jar

%endif

%if %{gcj_support}
# Remove non-standard jars from the list for aot compilation 
aot-compile-rpm \
    --exclude var/lib/%{name}/webapps/tomcat-docs/appdev/sample/sample.war \
    --exclude var/lib/%{name}/webapps/servlets-examples/WEB-INF/classes \
    --exclude var/lib/%{name}/webapps/jsp-examples/WEB-INF/classes \
    --exclude var/lib/%{name}/webapps/jsp-examples/plugin/applet \
    --exclude var/lib/%{name}/server/lib/servlets-cgi.renametojar \
    --exclude var/lib/%{name}/server/lib/servlets-ssi.renametojar
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if %{without_apisonly}
%post
# install tomcat5 (but don't activate)
/sbin/chkconfig --add %{name}
# Create automated links - since all needed extensions may not have been
# installed for this jvm output is muted
# Try to set a sensible jvm
unset JAVA_HOME
[ -r %{confdir}/tomcat5.conf ] && . %{confdir}/tomcat5.conf
[ -z "$JAVA_HOME" ] && [ -r %{_sysconfdir}/java/java.conf ] && \
    . %{_sysconfdir}/java/java.conf
[ -z "$JAVA_HOME" ] && JAVA_HOME=%{_jvmdir}/java
# Remove old automated symlinks
for repository in %{commondir}/endorsed ; do
    find $repository -name '\[*\]*.jar' -not -type d | xargs rm -f
done
build-jar-repository %{commondir}/endorsed jaxp_parser_impl \
                                           xml-commons-apis 2>&1
build-jar-repository %{bindir} mx4j/mx4j 2>&1
%if %{gcj_support}
%{_bindir}/rebuild-gcj-db
%endif

%if %{gcj_support}
%postun
%{_bindir}/rebuild-gcj-db
%endif

%post common-lib
# Create automated links - since all needed extensions may not have been
# installed for this jvm output is muted
# Try to set a sensible jvm
unset JAVA_HOME
[ -r %{confdir}/tomcat5.conf ] && . %{confdir}/tomcat5.conf
[ -z "$JAVA_HOME" ] && [ -r %{_sysconfdir}/java/java.conf ] && \
    . %{_sysconfdir}/java/java.conf
[ -z "$JAVA_HOME" ] && JAVA_HOME=%{_jvmdir}/java
# Remove old automated symlinks
for repository in %{commondir}/lib ; do
    find $repository -name '\[*\]*.jar' -not -type d | xargs rm -f
done
build-jar-repository %{commondir}/lib ant commons-collections commons-dbcp \
                                      commons-el commons-logging-api \
                                      commons-pool jaf javamail jdbc-stdext \
                                      jndi jsp \
                                      mx4j/mx4j \
                                      servlet %{jname}5-compiler \
                                      %{jname}5-runtime 2>&1
#build-jar-repository %{commondir}/lib geronimo-jta-1.0.1B-api 2>&1
build-jar-repository %{commondir}/lib jta 2>&1
%if %{with_ecj}
pushd %{commondir}/lib > /dev/null
ln -sf %{_javadir}/jdtcore.jar .
popd > /dev/null
%endif
%if %{gcj_support}
%{_bindir}/rebuild-gcj-db
%endif

%if %{gcj_support}
%postun common-lib
%{_bindir}/rebuild-gcj-db
%endif

%post server-lib
# Create automated links - since all needed extensions may not have been
# installed for this jvm output is muted
# Try to set a sensible jvm
unset JAVA_HOME
[ -r %{confdir}/tomcat5.conf ] && . %{confdir}/tomcat5.conf
[ -z "$JAVA_HOME" ] && [ -r %{_sysconfdir}/java/java.conf ] && \
    . %{_sysconfdir}/java/java.conf
[ -z "$JAVA_HOME" ] && JAVA_HOME=%{_jvmdir}/java
# Remove old automated symlinks
for repository in %{serverdir}/lib ; do
    find $repository -name '\[*\]*.jar' -not -type d | xargs rm -f
done
build-jar-repository %{serverdir}/lib catalina-ant5 commons-beanutils \
                                      commons-digester commons-el \
                                      commons-fileupload commons-logging \
                                      commons-modeler jaas mx4j/mx4j \
                                      regexp 2>&1
%if %{with_ecj}
pushd %{serverdir}/lib > /dev/null
ln -sf %{_javadir}/jdtcore.jar .
popd > /dev/null
%endif
%if %{gcj_support}
%{_bindir}/rebuild-gcj-db
%endif

%if %{gcj_support}
%postun server-lib
%{_bindir}/rebuild-gcj-db
%endif

%post webapps 
# Create automated links - since all needed extensions may not have been
# installed for this jvm output is muted
# Try to set a sensible jvm
unset JAVA_HOME
[ -r %{confdir}/tomcat5.conf ] && . %{confdir}/tomcat5.conf
[ -z "$JAVA_HOME" ] && [ -r %{_sysconfdir}/java/java.conf ] && \
    . %{_sysconfdir}/java/java.conf
[ -z "$JAVA_HOME" ] && JAVA_HOME=%{_jvmdir}/java
build-jar-repository %{appdir}/jsp-examples/WEB-INF/lib \
      jakarta-taglibs-core jakarta-taglibs-standard 2>&1
%if %{gcj_support}
%{_bindir}/rebuild-gcj-db
%endif

%if %{gcj_support}
%postun webapps
%{_bindir}/rebuild-gcj-db
%endif

%post admin-webapps
# Create automated links - since all needed extensions may not have been
# installed for this jvm output is muted
# Try to set a sensible jvm
unset JAVA_HOME
[ -r %{confdir}/tomcat5.conf ] && . %{confdir}/tomcat5.conf
[ -z "$JAVA_HOME" ] && [ -r %{_sysconfdir}/java/java.conf ] && \
    . %{_sysconfdir}/java/java.conf
[ -z "$JAVA_HOME" ] && JAVA_HOME=%{_jvmdir}/java
# Remove old automated symlinks
find %{serverdir}/webapps/admin/WEB-INF/lib -name '\[*\]*.jar' \
     -not -name 'catalina-admin*' -not -type d | xargs rm -f
build-jar-repository %{serverdir}/webapps/admin/WEB-INF/lib struts 2>&1
%if %{gcj_support}
%{_bindir}/rebuild-gcj-db
%endif

%if %{gcj_support}
%postun admin-webapps
%{_bindir}/rebuild-gcj-db
%endif
%endif

%post servlet-%{servletspec}-api
update-alternatives --install %{_javadir}/servlet.jar servlet \
    %{_javadir}/%{name}-servlet-%{servletspec}-api.jar 20400
%if %{gcj_support}
%{_bindir}/rebuild-gcj-db
%endif

%post servlet-%{servletspec}-api-javadoc
rm -f %{_javadocdir}/servletapi # legacy symlink
rm -f %{_javadocdir}/%{name}-servlet-%{servletspec}-api
ln -s %{name}-servlet-%{servletspec}-api-%{version} \
    %{_javadocdir}/%{name}-servlet-%{servletspec}-api

%postun servlet-%{servletspec}-api
if [ "$1" = "0" ]; then
    update-alternatives --remove servlet \
        %{_javadir}/%{name}-servlet-%{servletspec}-api.jar
fi
%if %{gcj_support}
%{_bindir}/rebuild-gcj-db
%endif

%post jsp-%{jspspec}-api
update-alternatives --install %{_javadir}/jsp.jar jsp \
    %{_javadir}/%{name}-jsp-%{jspspec}-api.jar 20000
%if %{gcj_support}
%{_bindir}/rebuild-gcj-db
%endif

%post jsp-%{jspspec}-api-javadoc
rm -f %{_javadocdir}/jsp-api # legacy symlink
rm -f %{_javadocdir}/%{name}-jsp-%{jspspec}-api
ln -s %{name}-jsp-%{jspspec}-api-%{version} \
    %{_javadocdir}/%{name}-jsp-%{jspspec}-api

%postun jsp-%{jspspec}-api
if [ "$1" = "0" ]; then
    update-alternatives --remove jsp \
        %{_javadir}/%{name}-jsp-%{jspspec}-api.jar
fi
%if %{gcj_support}
%{_bindir}/rebuild-gcj-db
%endif

%if %{without_apisonly}
%preun
# Always clean up workdir and tempdir on upgrade/removal
rm -fr %{workdir}/* %{tempdir}/*
if [ $1 = 0 ]; then
    [ -f /var/lock/subsys/%{name} ] && %{_sysconfdir}/rc.d/init.d/%{name} stop
    [ -f %{_sysconfdir}/rc.d/init.d/%{name} ] && /sbin/chkconfig --del %{name}
    # Remove automated symlinks
    for repository in %{commondir}/endorsed ; do
        find $repository -name '\[*\]*.jar' -not -type d | xargs rm -f
    done
fi

%preun server-lib
if [ $1 = 0 ]; then
    # Remove automated symlinks
    for repository in %{serverdir}/lib ; do
        find $repository -name '\[*\]*.jar' -not -type d | xargs rm -f
    done
fi

%preun common-lib
if [ $1 = 0 ]; then
    # Remove automated symlinks
    for repository in %{commondir}/lib ; do
        find $repository -name '\[*\]*.jar' -not -type d | xargs rm -f
    done
fi

%preun admin-webapps
if [ $1 = 0 ]; then
    find %{serverdir}/webapps/admin/WEB-INF/lib  \
         -name '\[*\]*.jar' \
         -not -name 'catalina-admin*' -not -type d | xargs rm -f
fi

%preun webapps
if [ $1 = 0 ]; then
    find %{appdir}/jsp-examples/WEB-INF/lib  \
         -name '\[*\]*.jar' \
         -not -type d | xargs rm -f
fi

%pre
# Add the "tomcat" user and group
# we need a shell to be able to use su - later
%{_sbindir}/groupadd -g %{tcuid} -r tomcat 2> /dev/null || :
%{_sbindir}/useradd -c "Tomcat" -u %{tcuid} -g tomcat \
    -s /bin/sh -r -d %{homedir} tomcat 2> /dev/null || :
%endif

%if %{without_apisonly}
%files -f %{packdname}/homelinks
%defattr(644,root,root,755)
%doc %{packdname}/build/{LICENSE,RELE*,RUNNING.txt,BENCHMARKS.txt}
# Normal directories
%dir %{homedir}
%dir %{bindir}
%dir %{_localstatedir}/lib/%{name}
%dir %{_localstatedir}/cache/%{name}
%dir %{commondir}
%dir %{commondir}/classes
%dir %{commondir}/lib
%dir %{commondir}/endorsed
%dir %{commondir}/i18n
%dir %{serverdir}/
%dir %{serverdir}/classes
%dir %{serverdir}/lib
%dir %{shareddir}
%dir %{shareddir}/classes
%dir %{shareddir}/lib
# Directories with special permissions
%attr(775,root,tomcat) %dir %{appdir}
%attr(775,root,tomcat) %dir %{confdir}
%attr(775,root,tomcat) %dir %{tempdir}
%attr(775,root,tomcat) %dir %{workdir}
%attr(775,root,tomcat) %dir %{logdir}
%attr(644,root,tomcat) %{logdir}/catalina.out
%attr(775,root,tomcat) %dir %{confdir}/Catalina
%attr(775,root,tomcat) %dir %{confdir}/Catalina/localhost
%attr(755,root,root) %{_bindir}/*
%attr(755,root,root) %{bindir}/*
%attr(755,root,root) %{_sysconfdir}/rc.d/init.d/%{name}
%attr(644,root,tomcat) %config(noreplace) %{confdir}/catalina.policy
%attr(644,root,tomcat) %config(noreplace) %{confdir}/catalina.properties
%attr(660,root,tomcat) %config(noreplace) %{confdir}/jk2.properties
%attr(660,root,tomcat) %config(noreplace) %{confdir}/logging.properties
%attr(660,root,tomcat) %config(noreplace) %{confdir}/tomcat-users.xml
%config(noreplace) %{confdir}/tomcat5.conf
%config(noreplace) %{confdir}/server-minimal.xml
%config(noreplace) %{confdir}/server.xml
%config(noreplace) %{confdir}/web.xml
%config(noreplace) %{confdir}/context.xml
%config(noreplace) %{confdir}/jk2.manifest
%config(noreplace) %{confdir}/jkconf.ant.xml
%config(noreplace) %{confdir}/jkconfig.manifest
%config(noreplace) %{confdir}/shm.manifest
%config(noreplace) %{confdir}/tomcat-jk2.manifest
%config(noreplace) %{confdir}/uriworkermap.properties
%config(noreplace) %{confdir}/workers.properties
%config(noreplace) %{confdir}/workers.properties.minimal
%config(noreplace) %{confdir}/workers2.properties
%config(noreplace) %{confdir}/workers2.properties.minimal
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%{commondir}/i18n/*
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/bootstrap*
%attr(-,root,root) %{_libdir}/gcj/%{name}/commons-daemon*
%attr(-,root,root) %{_libdir}/gcj/%{name}/commons-logging-api*
#%attr(-,root,root) %{_libdir}/gcj/%{name}/tomcat-juli*
%attr(-,root,root) %{_libdir}/gcj/%{name}/tomcat-jkstatus-ant*
%endif

%files common-lib
%defattr(644,root,root,755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/naming*.jar
%{commondir}/lib/*
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/naming-*
%endif

%files server-lib
%defattr(644,root,root,755)
%{_javadir}/catalina*.jar
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/catalina-ant-jmx*.jar
%{_javadir}/%{name}/catalina-cluster*.jar
%{_javadir}/%{name}/catalina.jar
%{_javadir}/%{name}/catalina-%{version}.jar
%{_javadir}/%{name}/catalina-optional*.jar
%{_javadir}/%{name}/catalina-storeconfig*.jar
%{_javadir}/%{name}/servlets*.jar
%{_javadir}/%{name}/tomcat*.jar
%{serverdir}/lib/*
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/catalina-ant*
%attr(-,root,root) %{_libdir}/gcj/%{name}/catalina-cluster*
%attr(-,root,root) %{_libdir}/gcj/%{name}/catalina-optional*
%attr(-,root,root) %{_libdir}/gcj/%{name}/catalina-storeconfig*
%attr(-,root,root) %{_libdir}/gcj/%{name}/catalina-%{version}.jar*
#%attr(-,root,root) %{_libdir}/gcj/%{name}/servlets-cgi*
%attr(-,root,root) %{_libdir}/gcj/%{name}/servlets-default*
%attr(-,root,root) %{_libdir}/gcj/%{name}/servlets-invoker*
#%attr(-,root,root) %{_libdir}/gcj/%{name}/servlets-ssi*
%attr(-,root,root) %{_libdir}/gcj/%{name}/servlets-webdav*
%attr(-,root,root) %{_libdir}/gcj/%{name}/tomcat-ajp*
%attr(-,root,root) %{_libdir}/gcj/%{name}/tomcat-apr*
%attr(-,root,root) %{_libdir}/gcj/%{name}/tomcat-coyote*
%attr(-,root,root) %{_libdir}/gcj/%{name}/tomcat-http*
%attr(-,root,root) %{_libdir}/gcj/%{name}/tomcat-util*
%endif

%files webapps
%defattr(644,root,tomcat,775)
%dir %{appdir}/servlets-examples
%{appdir}/servlets-examples/*
%dir %{appdir}/jsp-examples
%{appdir}/jsp-examples/*
%dir %{appdir}/ROOT
%{appdir}/ROOT/*
%dir %{appdir}/tomcat-docs
%{appdir}/tomcat-docs/*
%dir %{appdir}/webdav
%{appdir}/webdav/*
#%attr(-,root,root) %{_libdir}/gcj/%{name}/applet*
%if %{gcj_support}
%ifnarch ppc64 s390x
%attr(-,root,root) %{_libdir}/gcj/%{name}/catalina-root*
%endif
#%attr(-,root,root) %{_libdir}/gcj/%{name}/jsp-examples*
#%attr(-,root,root) %{_libdir}/gcj/%{name}/sample*
#%attr(-,root,root) %{_libdir}/gcj/%{name}/servlets-examples*
%endif

%files admin-webapps
%defattr(640,root,tomcat,750)
%attr(660,root,tomcat) %{confdir}/Catalina/localhost/manager.xml
%attr(660,root,tomcat) %{confdir}/Catalina/localhost/host-manager.xml
%{confdir}/Catalina/localhost/admin.xml
%dir %{appdir}/balancer
%{appdir}/balancer/*
%dir %{serverdir}/webapps
%{serverdir}/webapps/*
%attr(644,root,root) %{_javadir}/%{name}/catalina-admin*.jar
%attr(644,root,root) %{_javadir}/%{name}/catalina-manager*.jar
%attr(644,root,root) %{_javadir}/%{name}/catalina-host-manager*.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/catalina-admin*
%attr(-,root,root) %{_libdir}/gcj/%{name}/catalina-balancer*
%attr(-,root,root) %{_libdir}/gcj/%{name}/catalina-host-manager*
%attr(-,root,root) %{_libdir}/gcj/%{name}/catalina-manager*
%attr(-,root,root) %{_libdir}/gcj/%{name}/commons-fileupload*
%endif

%files %{jname}
%defattr(644,root,root,755)
%doc $RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/%{jname}/doc/jspc.html
%{_javadir}/%{jname}5-*.jar
%attr(755,root,root) %{_bindir}/%{jname}*.sh
%attr(755,root,root) %{_bindir}/jspc*.sh
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{jname}5-*
%endif

%files %{jname}-javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{jname}-%{version}
%ghost %doc %{_javadocdir}/%{jname}
%endif

%files servlet-%{servletspec}-api
%defattr(-,root,root)
%doc %{packdname}/build/LICENSE
%{_javadir}/%{name}-servlet-%{servletspec}-api*.jar
%{_javadir}/servletapi5.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-servlet-%{servletspec}-api*
%endif

%files servlet-%{servletspec}-api-javadoc
%defattr(-,root,root)
%doc %{_javadocdir}/%{name}-servlet-%{servletspec}-api-%{version}
%ghost %doc %{_javadocdir}/%{name}-servlet-%{servletspec}-api

%files jsp-%{jspspec}-api
%defattr(-,root,root)
%doc %{packdname}/build/LICENSE
%{_javadir}/%{name}-jsp-%{jspspec}-api*.jar
%{_javadir}/jspapi.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-jsp-%{jspspec}-api*
%endif

%files jsp-%{jspspec}-api-javadoc
%defattr(-,root,root)
%doc %{_javadocdir}/%{name}-jsp-%{jspspec}-api-%{version}
%ghost %doc %{_javadocdir}/%{name}-jsp-%{jspspec}-api

%changelog
* Thu Mar 29 2012 David Knox <dknox@redhat.com> 0:5.5.23-0jpp.31
- Resolves: CVE-2012 regression. Changed patch file.

* Fri Mar 9 2012 David Knox <dknox@redhat.com> 0:5.5.23-0jpp.30
- Resolves: CVE-2012-0022, CVE-2011-4858

* Mon Nov 7 2011 David Knox <dknox@redhat.com> 0:5.5.23-0jpp.27
- Resolves CVE-2011-0013 rhbz 675933
- Resolves CVE-2011-3718 rhbz 675933

* Wed Nov 2 2011 David Knox <dknox@redhat.com> 0:5.5.23-0jpp.23
- Resolves CVE-2011-1184 rhbz 744984
- Resolves CVE-2011-2204 rhbz 719188

#* Tue Oct 18 2011 David Knox <dknox@redhat.com> 0:5.5.23-0jpp.22
#- Resolves rhbz 543995 TRACE option returned when not allowed

#* Thu Jul 14 2011 David Knox <dknox@redhat.com> 0:5.5.23-0jpp.21
#- Resolves CVE-2011-2526 (Not currently applied)

#* Wed Jun 22 2011 David Knox <dknox@redhat.com> 0:5.5.23-0jpp.20
#- Resolves rhbz 691833 - NPE when deploying context.xml in Catalina/localhost

#* Wed May 18 2011 David Knox <dknox@redhat.com> 0:5.5.23-0jpp.19
#- Resolves: rhbz 689924 - NPE on start

#* Wed Feb 2 2011 David Knox <dknox@redhat.com> 0:5.5.23-0jpp.18
#- Resolves: rhbz 674601 - JDK Double.parseDouble DoS

#* Thu Dec 9 2010 David Knox <dknox@redhat.com> 0:5.5.23-0jpp.17
#- Resolves: rhbz 530089 - cookieparsing error
# - Port patches for JBPAPP-3626 and 3627

* Thu Dec 9 2010 David Knox <dknox@redhat.com> 0:5.5.23-0jpp.16
- Resolves: rhbz 623465 - NPE and ConcurrentModification Exception

* Wed Dec 8 2010 David Knox <dknox@redhat.com> 0:5.5.23-0jpp.15
- Resolves: rhbz#217630, 217141 naming-factory-dbcp.jar missing causes
- JNDI errors. Change made to tomcat5.conf, added javax.sql.DataSource.
- Factory to JAVA_OPTS

* Tue Sep 28 2010 David Knox <dknox@redhat.com> 0:5.5.23-0jpp.14
- Resolves rhbz#613005, rhbz#584514

* Wed Aug 4 2010 David Knox <dknox@redhat.com> 0:5.5.23-0jpp.13
- Fixed problem with CVE 2009-2902 which introduced a stack overflow
- Resolves: rhbz#620996

* Wed Jul 28 2010 David Knox <dknox@redhat.com> 0:5.5.23-0jpp.12
- Adding the patch for 0781 to cvs 
-
* Thu Jul 15 2010 David Knox <dknox@redhat.com> 0:5.5.23-0jpp.11
- Initscript edited to correct permissions and made partially LSB compliant

* Fri Apr 23 2010 David Knox <dknox@redhat.com> 0:5.5.23-0jpp.10
- Resolves:rhbz#584514 

* Wed Aug 9 2009 David Knox <dknox@redhat.com> 0:5.5.23-0jpp.9.1t
- Test build to merge CVE-2009-0781

* Thu Jun 25 2009 Fernando Nasser <fnasser@redhat.com> 0:5.5.23-0jpp.9
- Merge fixes from Z-Streams to incorporate fixes for:
  Resolves: rhbz#427780 rhbz#504759 rhbz#503981 rhbz#504163
  Resolves: rhbz#457727 rhbz#449917 rhbz#458635 rhbz#456216

* Thu Jun 25 2009 Fernando Nasser <fnasser@redhat.com> 0:5.5.23-0jpp.7.2
  From  David Knox <dknox@redhat.com>:
- add patch for CVE-2007-5333
  Resolves: rhbz#427780
- add patch for CVE-2008-5515
  Resolves: rhbz#504759
- add patch for CVE-2009-0033
- add patch for CVE-2009-0580
  Resolves: rhbz#503981
- add patch for CVE-2009-0783
  Resolves: rhbz#504163

* Mon Jun 22 2009 David Knox <dknox@redhat.com> - 0:5.5.23-0jpp.8
- First attempt to merge in:
  Resolves: rhbz#427780 rhbz#504759 rhbz#503981 rhbz#504163
  Resolves: rhbz#457727 rhbz#449917 rhbz#458635 rhbz#456216

* Fri Aug 22 2008 David Walluck <dwalluck@redhat.com> 0:5.5.23-0jpp.7.1
- add patch for CVE-2008-1232
  Resolves: rhbz#457727
- add patch for CVE-2008-1947
  Resolves: rhbz#449917
- add patch for CVE-2008-2370
  Resolves: rhbz#458635
- add patch for CVE-2008-2938
  Resolves: rhbz#456216

* Wed Feb 27 2008 Deepak Bhole <dbhole@redhat.com> - 0:5.5.23-0jpp.7
- Patch for CVE-2007-5342
  Resolves: bz# 427777
- Patch for CVE-2007-5461
  Resolves: bz# 334571

* Mon Jan 28 2008 Deepak Bhole <dbhole@redhat.com> - 0:5.5.23-0jpp.6
- Resolves: bz# 240739. Update version string

* Thu Aug 30 2007 Fernando Nasser <fnasser@redhat.com> - 0:5.5.23-0jpp.5
  From jean-frederic clere <jclere@redhat.com>:
- Patch for CVE-2007-3382 and CVE-2007-3385
  Resolves: rhbz#254156

* Wed Aug 29 2007 Fernando Nasser <fnasser@redhat.com> - 0:5.5.23-0jpp.4
  From jean-frederic clere <jclere@redhat.com>:
- Patch for CVE-2007-3386
  Resolves: rhbz#254156

* Mon Jun 19 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:5.5.23-0jpp.3
- Remove erroneous rebuild-gcj-db for javadoc subpackage
- Add fixes for CVE-2007-2449 and CVE-2007-2450
- Resolves: bug 244846, bug 244817

* Tue May 8 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:5.5.23-0jpp.2
- Rebuild
- Add catalina.out to the rpm and set explicit permissions; tomcat ownership
- Resolves: bug 237088

* Mon Apr 23 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:5.5.23-0jpp.1
- Resolves: bug 237088 
- Merge 0:5.5.17-8jpp.2 with sources/patches from 5.5.23
- Build against jakarta-commons-modeler 1.1 with MODELER-15 patch

* Thu Jan 18 2007 Rafael Schloming <rafaels@redhat.com> - 0:5.5.17-8jpp.2
- Changed PreReq to Requires(pre)

* Wed Oct 4 2006 Fernando Nasser <fnasser@redhat.com> 0:5.5.17-8jpp.1
- Merge with upstream

* Wed Oct 4 2006 Permaine Cheung <pcheung@redhat.com> 0:5.5.17-8jpp
- Fix condrestart in init script and location of init script in the spec file.

* Mon Oct 2 2006 Permaine Cheung <pcheung@redhat.com> 0:5.5.17-7jpp
- Add the new config file, and add the CONNECTOR_PORT variable in it.

* Mon Oct 2 2006 Permaine Cheung <pcheung@redhat.com> 0:5.5.17-6jpp
- Add the ability to start multiple instances of tomcat on the same machine.

* Wed Aug 30 2006 Deepak Bhole <dbhole@redhat.com> 5.5.17-6jpp.2
- Rebuilding.

* Mon Aug 21 2006 Fernando Nasser <fnasser@redhat.com> 0:5.5.17-6jpp.1
- Merge with upstream

* Mon Aug 21 2006 Fernando Nasser <fnasser@redhat.com> 0:5.5.17-6jpp
- Rebuild

* Mon Aug 21 2006 Fernando Nasser <fnasser@redhat.com> 0:5.5.17-5jpp
  From Andrew Overholt <overholt@redhat.com>:
- Silence post common-lib and server-lib.

* Thu Jul 27 2006 Fernando Nasser <fnasser@redhat.com> 0:5.5.17-3jpp_5fc
- Fix regression in relink with patch from Matt Wringe

* Sat Jul 22 2006 Jakub Jelinek <jakub@redhat.com> - 0:5.5.17-3jpp_4fc
- Rebuilt

* Thu Jul 13 2006 Fernando Nasser <fnasser@redhat.com> 0:5.5.17-3jpp_3fc
- Rebuild in full

* Wed Jul 05 2006 Fernando Nasser <fnasser@redhat.com> 0:5.5.17-3jpp_2fc
- Re-enable ppc64 and s390x
- Disable JSP pre-compilation on ppc64 and x390x (FIXME)
- Bootstrap mode (with apisonly) build

* Wed Jul 05 2006 Fernando Nasser <fnasser@redhat.com> 0:5.5.17-3jpp_1fc
- Full build
- Do not build on ppc64 and s390x
- Fix servlet-api.jar path
- Add version to catalina .so
From Ralph Apel <rapel@redhat.com>:
- Re-add patch to add rt.jar
- Add mx4j JMX API and struts to classpath

* Wed Jul 05 2006 Fernando Nasser <fnasser@redhat.com> 0:5.5.17-3jpp_0fc
- Upgrade
- Use any JTA for now
- Try and remove exclude for sample.war
- Bootstrap build with apisonly

* Wed Jul 05 2006 Fernando Nasser <fnasser@redhat.com> 0:5.5.17-3jpp_1rh
- Merge with upstream

* Fri Jun 30 2006 Ralph Apel <r.apel@r-apel.de> 0:5.5.17-3jpp
- Create option --with apisonly to build just tomcat5-servlet-2.4-api,
  tomcat5-jsp-2.0-api and its -javadoc subpackages
- Create option --without ecj to build even when eclipse-ecj not available
- Drop several unnecessary export CLASSPATH=

* Sat Jun 17 2006 Deepak Bhole <dbhole@redhat.com> - 0:5.5.15-1jpp_7fc
- Re-enable ppc64, s390 and s390x architectures now that eclipse is built there

* Mon May 15 2006 Fernando Nasser <fnasser@redhat.com> 0:5.5.17-2jpp_1rh
- Merge with upstream for upgrade to 5.5.17

* Mon May 15 2006 Fernando Nasser <fnasser@redhat.com> 0:5.5.17-2jpp
- Requires on post things that are linked to at post
  Merge changes from downstream:
- Fix line breaks in the tomcat5 init script
- Split preun section among main package and the two new subpackages
- Move catalina-ant*.jar to the server-lib subpackage to avoid circular
  dependency with the main package
- Remove leading zero from alternative priorities
- Rebuild with new classpath-mail as javamail alternative
- Update versions of dependencies and move them to library subpackages
- Use only jta from geronimo-specs

* Mon May 15 2006 Fernando Nasser <fnasser@redhat.com> 0:5.5.17-1jpp
- Upgrade to 5.5.17
- Remove jasper2 subdirectory of jasper from patches and this spec file

* Wed Apr 19 2006 Ralph Apel <r.apel@r-apel.de> 0:5.5.16-3jpp
- Drop jdtCompilerAdapter from build-jar-repository
- Use ant-trax in static webapp build
- Duplicate admin-webapps jars in _javadir and make them world readable
- Direct install of common-lib and server-lib to _javadir and symlink for TC5

* Tue Apr 04 2006 Ralph Apel <r.apel@r-apel.de> 0:5.5.16-2jpp
- Require eclipse-ecj >= 3.1.1 and adapt to it

* Fri Mar 24 2006 Ralph Apel <r.apel@r-apel.de> 0:5.5.16-1jpp
- Upgrade to 5.5.16

* Mon Mar  6 2006 Jeremy Katz <katzj@redhat.com> - 0:5.5.15-1jpp_6fc
- stop scriptlet spew

* Fri Mar  3 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:5.5.15-1jpp_5fc
- Require java-gcj-compat for post and postun sections of
  servlet-%{servletspec}-api, jsp-%{jspspec}-api-javadoc and
  server-lib sub-packages, since these three packages call
  %{_bindir}/rebuild-gcj-db in their post and/or postun sections.

* Wed Mar  1 2006 Rafael Schloming <rafaels@redhat.com> - 0:5.5.15-1jpp_4fc
- Disabled juli logging as a workaround for a number of classpath bugs
- in java.util.logging.*

* Thu Feb 23 2006 Rafael Schloming <rafaels@redhat.com> - 0:5.5.15-1jpp_3fc
- Added jasper-foo symlinks for jars.

* Wed Feb 22 2006 Rafael Schloming <rafaels@redhat.com> - 0:5.5.15-1jpp_2fc
- Exclude ppc64 s390 s390x

* Wed Feb 22 2006 Rafael Schloming <rafaels@redhat.com> - 0:5.5.15-1jpp_1fc
- Updated to 5.5.15

* Tue Feb 14 2006 Ralph Apel <r.apel@r-apel.de> 0:5.5.12-2jpp
- Fix jta.jar location

* Fri Nov 11 2005 Fernando Nasser <fnasser@redhat.com> 0:5.5.12-1jpp
- Place jsp in its own subpackage
- Fix alternative links to jsp and servlet
- Fix alternative priorities to jsp and servlet
- Create library subpackages: common-lib and server-lib
  From Vadim Nasardinov <vadimn@redhat.com> 0:5.5.12-1jpp
- Upgrade to 5.5.12
  From Deepak Bhole <dbhole@redhat.com>
- Fix init script so it works with SELinux

* Wed Jun 08 2005 Fernando Nasser <fnasser@redhat.com> 0:5.5.9-1jpp
- Merge for upgrade
- Change the user to tomcat from tomcat4
- Relax permissions on appdir directory so jonas package can build
- Remove spurious links to log4j.jar from common and server/lib
- Remove spurious dependency on tyrex (only needed for tomcat4)
- Make sure the main package installs first so user tomcat is created
- Reinstate ssl code changes so that tomcat can be built with other SDKs
  and not only with Sun's or BEA's.

* Mon May 09 2005 Fernando Nasser <fnasser@redhat.com> 0:5.5.9-1jpp
- Upgrade to 5.5.9
- Add jmx to bindir and lower requirement to java 1.4.2

* Fri Feb 04 2005 Jason Corley 0:5.5.7-2jpp
- Add provides servletapi5 in addition to obsoletes servletapi5 (Martin Grotzke)

* Thu Feb 03 2005 Jason Corley 0:5.5.7-1jpp
- Upgrade to current stable release, 5.5.7

* Fri Jan 31 2005 Jason Corley 0:5.5.4-17jpp
- Use new eclipse-ecj package to remove old jasper-compiler-jdt.jar hack

* Thu Jan 27 2005 Jason Corley 0:5.5.4-16jpp
- Attempt to replace non-free jta with free geronimo-specs

* Thu Jan 27 2005 Jason Corley 0:5.5.4-15jpp
- Clean rebuild

* Thu Dec 16 2004 Jason Corley 0:5.5.4-14jpp
- First attempt at jasper subpackages

* Thu Dec 16 2004 Jason Corley 0:5.5.4-13jpp
- Yet another "servletapi" naming scheme change

* Tue Dec 14 2004 Jason Corley 0:5.5.4-12jpp
- Update the servletapi and servletapi-javadoc subpackages to the way proposed
  by Gary Benson (based on work by Ralph Apel) in the 5.0.30 RPMs

* Wed Dec 08 2004 Jason Corley 0:5.5.4-10jpp
- Incorporate Fernando Nasser's javaxssl patch from the tomcat 5.0.28 RPM
- Replace find ... -exec's with find | xargs

* Tue Dec 07 2004 Jason Corley 0:5.5.4-9jpp
- First attempt at the whole servletapi issue
- Replace jmxri references with mx4j
- Build with JDK 1.4 and require a 1.4 JDK to run
- Remove cruft
- Clearly lost track of some stuff between changelog entries ;-)

* Fri Dec 03 2004 Jason Corley 0:5.5.4-1jpp
- First attempt at building 5.5

* Fri Sep 10 2004 Fernando Nasser <fnasser@redhat.com> 0:5.0.27-4jpp
- Rebuild using Tyrex 1.0.1

* Sat Sep 04 2004 Fernando Nasser <fnasser@redhat.com> 0:5.0.27-3jpp
- Rebuild with Ant 1.6.2

* Fri Jul 16 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.27-2jpp
- Oops, don't require mx4j 2.0.1. 1.1.1 or later should be enough.
  jmxri won't work anymore since tc5 needs mx4j-tools.

* Fri Jul 16 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.27-1jpp
- Update to 5.0.27 (stable)
- Don't remove tomcat4 user/group on uninstall see the mailing list
  for discussion
- build w/ xml-apis.jar instead of xmlParserAPIs.jar (release notes 5.0.27)
- Require junit 3.8.1 or newer (release notes 5.0.26)
- Require jakarta-commons-dbcp 1.2.1 or newer (release notes 5.0.27)
- Require jakarta-commons-logging 1.0.4 or newer (release notes 5.0.27)
- Require jakarta-commons-pool 1.1 or newer (release notes 5.0.27)

* Wed Jun 09 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.24-3jpp
- Change default webapps file permissions from 0640 -> 0644

* Tue Jun 08 2004 Fernando Nasser <fnasser@redhat.com> 0:5.0.24-2jpp
- Allow browsing of webapps directory so that JOnAS can build.

* Mon May 17 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.24-1jpp
- Update to 5.0.24
- Require xerces-j2 2.6.2 (release notes 5.0.21), also require ant < 1.6
  as tomcat5 doesn't seem to build cleanly with 1.6 yet.

* Fri Mar 19 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.19-2jpp
- Set JAVA_ENDORSED_DIRS by default in tomcat5.conf, it is otherwise empty
  Suggestion from Aleksander Adamowski <aleksander.adamowski@altkom.pl>  

* Wed Feb 25 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.19-1jpp
- Update to 5.0.19

* Fri Jan 23 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.18-1jpp
- Update to 5.0.18
- Build catalina before connectors
- Hack connectors build
- Require xerces-j2 2.6.0 (release notes 5.0.17)

* Sat Jan 17 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-4jpp
- Create TC4 user and group separately, lets TC5 work out of the box
  on Trustix (Patch from Iain Arnell)

* Sat Jan 10 2004 Kaj J. Niemi <kajtzu@fi.basen.net> - 0:5.0.16-3jpp
- servletapi5 is required
- move confdir/Catalina from admin-webapps to main package
  (otherwise we end up requiring tomcat5-admin-webapps for struts-webapps)

* Sat Jan 10 2004 Kaj J. Niemi <kajtzu@fi.basen.net> - 0:5.0.16-2jpp
- Fix conflict with tomcat4 catalina-ant.jar in %%_javadir by renaming it
  catalina-ant5.jar for now.

* Fri Jan  9 2004 Kaj J. Niemi <kajtzu@fi.basen.net> - 0:5.0.16-1jpp
- First build for JPackage

* Mon Dec 29 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.11
- Merge changes from tomcat4.init to tomcat5.init

* Mon Dec 22 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.10
- Some jsp-examples require jakarta-taglibs-standard to work

* Mon Dec 22 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.9.1
- Struts should be 1.1 or later according to the release notes
- The /admin webapp works now as well
- manager.xml needs to be group writeable, otherwise tomcat complains

* Fri Dec 19 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.7
- Accept an older version of xerces-j2 as well.

* Fri Dec 19 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.6
- Require xerces-j2 instead of just jaxp_parser_impl
- Require jpackage commons-logging instead of internal version

* Wed Dec 17 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.5
- Tomcat5 isn't beta anymore

* Wed Dec 17 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.beta.4
- Place jspapi, jmxri, commons-el in common/lib as mentioned in the
  upstream RELEASE-NOTES.txt. This makes jsps actually work.

* Wed Dec 17 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.beta.3
- Separated jakarta-commons-el from tomcat
- Require servletapi5 and jakata-commons-el
- Added Patch #4 (tomcat5-5.0.16-cluster-pathelement.patch) which fixes
  build failure when servlet-api is renamed something else than the default
- Added Patch #5 (tomcat5-5.0.16-skip-build-on-install.patch) which corrects
  servletapi/jspapi related build snafu on install. They're already built so
  it's OK to skip.

* Thu Dec  4 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.beta.1
- 5.0.16
- jakarta-commons-el included here instead of somewhere else for now,
  packaging unfinished
- Patch #3 removes dependency to jsvc.tar.gz which doesn't seem to be anywhere

* Tue Aug  5 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.12-0.beta.1
- Based on JPackage.org's tomcat4 .spec
- No compat stuff anymore.
- First build

